

def arcs(m):
    return [(i,j) for i in range(len(m))\
            for j in range(len(m)) if m[i][j]]

def arcs(m):
    l = []
    for i in range(len(m)):
        for j in range(len(m[i])):
            if m[i][j] == 1:
             l.append((i,j)) # O(1)
    return l

def arcs2mat(l):
    maxi = max([a[i] for a in l for i in [0,1]])
    m = [[0]*(maxi+1) for _ in range(maxi+1)]
    for i,j in l:
        m[i][j] = 1
    return m
    

def puits(g):
    #on doit avoir une colonne de 1
    def explore_col(j):
        return degmoins(g,j)==len(g) and\
        degplus(g,j)==1
    j=0
    while j<len(g):
        if explore_col(j): return True
        j+=1
    return False


def transpose(m):
    return [[ m[i][j] for i in range(len(m))]\
            for j in range(len(m))]

def transpose(m):
    res=[]
    for j in range(len(m)):
        lignej = []
        for i in range(len(m)):
            lignej.append(m[i][j])
        res.append(lignej)
    return res

def voisins(g,i):
    return [j for j in range(len(g)) if m[i][j]]

def voisins(g,i):
    res = []
    for j in range(len(g)):
        if m[i][j] ==  1:
            res.append(j)
    return res


def convertm(g):
    return [[(j in g[i])+0 for j in range(len(g))]\
            for i in range(len(g))]

def convertm(g):
    res = matrice_nulle(len(g),len(g))
    for i in range(len(g)):
        for j in range(len(g)):
            if j in g[i]:
                res[i][j] = 1
    return res


def arcs(m):
    return [(i,j) for i in range(len(m))\
            for j in range(len(m)) if m[i][j]]

def matrice_nulle(n,m):
    """n : nblignes, m : nbcols"""
    return [[0 for _ in range(m)]\
            for _ in range(n)]


def arcs2mat(l):
    maxi = max([c[i] for c in l for i in [0,1]])
    m = matrice_nulle(maxi+1,maxi+1)
    for i,j in l:
        m[i][j] = 1
    return m


def is_path(m,c):
    for i in range(len(c)-1):
        if not m[c[i]][c[i+1]]:
            return False
    return True


def profondeur(m,s,col):#s est supposé bleu
    col[s] = V
    for v in voisins(m,s):
        if col[v] == B:
            profondeur(m,v,col)
    col[s] = R

def accessibles(m,s):
    col =[B] * len(m)
    profondeur(m,s,col)
    return [i for i in range(len(col))\
            if col[i] == R]


class Cycle(Exception):
    pass

def cycle(m):
    col =[B] * len(m)    
    def dfs(s):
        for v in voisins(m,s):
            if col[v] == B:
                col[v] = V
                dfs(v)
            elif col[v] == V:
                1//0
        col[s] = R
    try :
        for s in range(len(m)):
            if col[s] == B:
                col[s] = V
                dfs(s)
        return False
    except ZeroDivisionError:
        return True


def cycle(m):
    col =[B] * len(m)    
    def dfs(s):
        for v in voisins(m,s):
            if col[v] == B:
                col[v] = V
                dfs(v)
            elif col[v] == V:
                return True
        col[s] = R
        return False
    for s in range(len(m)):
        if col[s] == B:
            col[s] = V
            if dfs(s) :
                return True
    return False







def profondeur(m,s,col):#s est bleu
    col[s] = V
    def dfs(s):
        for v in voisins(m,s):
            if col[v] == B:
                col[v] = V
                dfs(v)
        col[s] = R
    dfs(s)

def voisins(g,i):
    res = []
    for j in range(len(g)):
        if m[i][j] ==  1:
            res.append(j)
    return res

def profondeur(m,s,col):#s est bleu
    col[s] = V
    for v in voisins(m,s):
        if col[v] == B:
            profondeur(m,v,col)
        elif 
    col[s] = R


try :
    some code
    return false
except ZeroDivisionError:
    return True


def est_coloration(g,c):
    for i in range(len(m)):
        for j in range(len(m)):
            if m[i][j]==1 and\
               c[i] ==  c[j]:
                return False
    return True
    


#***************

def est_voisin(g,u,v):
    return bool(g[u][v]\
                or g[v][u]) 

def nb_de_voisins_dans(G,U,v):
    l = [u for u in U \
         if est_voisin(G,v,u)]
    return len(l)

def choisir_sommet_a_colorier(G,U1,U2):
    # peut-être un pb d'effet de bord
    d = {v:(nb_de_voisins_dans(m,U2,v),\
            -nb_de_voisins_dans(m,U1,v))\
         for v in U1}
    U1.sort(key = lambda v: d[v])
    return U1.pop()#effet de bord

#****************
#quadratique
def single(U):
    """
    U liste de sommets
    """
    res = []
    for i in range(len(U)):
        ajoute = True
        for j in range(i+1,len(U)):
            if U[j] == U[i]:
                ajoute = False
                break
        if ajoute:
            res.append(U[i])
    return res

def single(U):
    r = []
    for u in U:
        if u not in r:
            r.append(u)
    return r


"""
Pseudo-linéaire. 
Passage par la structure set (hors programme ?)
"""
def single(U):
    return list(set(U))

"""
Linéaire en moyenne.
Passage par les dictionnaires (au programme !)
"""
def single(U):
    temp={u:0 for u in U}#O(n)
    return [u for u in temp] #O(n)

#*****************
#on pourrait faire plus élégant avec la classe set
def transfert(G,U1,U2,v):
    newU1=[]
    for w in U1:
        if est_voisin(G,v,w):
            if not w in U2:#à améliorer
                U2.append(w)
        else:
            newU1.append(w)
    #U2 a été modifié;#on renvoie newU1
    return newU1

#***************
def rlf_rec(G,U1,color,k):
    if U1 == []:
        return color
    U2 = []
    while U1 != []:
        v = choisir_sommet_a_colorier(G,U1,U2)
        color[v]=k 
        U1=transfert(G,U1,U2,v)
    #U1 est devenu vide; U2 prend sa place
    return rlf_rec(G,U2,color,k+1)
    
def rlf(G):
    #tous les sommets sont dans U1 au départ
    n = len(G)
    #sommets susceptibles d'être 0-colorié
    U1 = [i for i in range(n)]
    color = [-1] * n # aucun sommet colorié
    return rlf_rec(G,U1,color,0)
